// Utility to Hjonify an e-mail address (or anything) from text to the ASCII &code; in attempt to thwart address-gathering bots.
// Idea from Jon Hjelle. FLTK version by nathan vander wilt, 13 Oct. 2004
// v0.9 - copied from one box to other
// v1.0 - worked
// v1.1 - clipboard option/functionality 14 Oct. 2004
// v1.2 - changed textbucks from Fl_Input to Fl_Output. Now annoying dings when you type there!
// who knows what v1.3 may bring! Perhaps the death of the ding, even! (v1.3 added icon, not present in this source for portability)
// v1.whatever added invisible focus to certain widgets


#include <FL/Fl.h>
#include <Fl/Fl_Window.h>
#include <FL/Fl_Input.h>
#include <FL/Fl_Output.h>
#include <FL/Fl_Button.h>
#include <FL/Fl_Check_Button.h>
#include <sstream>


using namespace std;

Fl_Window win(220,125,"To HTML code");
Fl_Input textbox(10,10,200,25);
Fl_Output textbucks(10,50,200,25);
Fl_Button button(25,90,40,25);
Fl_Check_Button check(85,95,10,10);

string convert(const char* email) {
 stringstream temp;
 string html_code;

 for (int i=0; i<strlen(email); i++) {
  temp << "&#" << (int)email[i] << ";";
 }

 temp >> html_code;
 return html_code;
}

void button_write(Fl_Widget*w, void* userdata) {
 string s=convert(textbox.value());
 textbucks.value(s.c_str());
 if (check.value()) Fl::copy(s.c_str(),strlen(s.c_str()),1);
}


int main(int argc, char *argv[]) {
 check.label("To clipboard");
 check.set();
 check.visible_focus(0);
 button.visible_focus(0);
 textbucks.visible_focus(0);
 button.label("Code");
 textbox.when(FL_WHEN_ENTER_KEY);
 button.callback(button_write);
 textbox.callback(button_write);
 win.show(argc, argv);
 return(Fl::run());
}
